' hub streamer
OBJ
  mb: "mbox16"

VAR
  byte cog 'Cog ID

PUB start(p_mbox_out_addr, p_mbox_in_addr, p_end_flag_addr, p_in, p_out, p_len) : success
{{ Start hub streamer in new cog; return True if successful.
   The hub streamer is the first and last participant in the processsor chain
   Parameters:
     p_mbox_out ... address of the mailbox for the producer (first in chain)
     p_mbox_in ... address of the mailbox for the consumer (last in chain)
     p_end_flag_addr ... address of the end flag
     p_in ... array with input data
     p_out ... array with output data
     p_len ... length of input array (= length of output array)
}}
  Stop
  MBI_START_ADDR := p_mbox_in_addr
  MBI_LEN_ADDR := p_mbox_in_addr + mb#MBOX_LEN_B
  MBO_START_ADDR := p_mbox_out_addr
  MBO_LEN_ADDR := p_mbox_out_addr + mb#MBOX_LEN_B
  END_FLAG_ADDR := p_end_flag_addr
  D_IN_ADDR := p_in
  D_OUT_ADDR := p_out
  D_LEN := p_len
  success := (cog := cognew(@hub_streamer, 0) + 1)

PUB Stop
''Stop hub streamer, if any.
  if cog
    cogstop(cog~ - 1)

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
DAT
                        org     0

hub_streamer
                        mov     in_addr, D_IN_ADDR
                        mov     in_endaddr, D_IN_ADDR
                        add     in_endaddr, D_LEN
                        mov     out_addr, D_OUT_ADDR
                        mov     end_flag, #0
:loop                   call    #hs_stream_in
                        call    #hs_stream_out
                        jmp     #:loop
'
' --------------------------------------------------
'
MBI_START_ADDR          long  0
MBI_LEN_ADDR            long  0
MBO_START_ADDR          long  0
MBO_LEN_ADDR            long  0
END_FLAG_ADDR           long  0
end_flag                long  0  ' internal end flag

r1                      long  0
r2                      long  0
r3                      long  0
p1                      long  0

'
' --------------------------------------------------
'
hs_stream_in
' WAIT
                        rdbyte  r1, MBO_LEN_ADDR wz
        if_z            test    end_flag, BIT7 wz
        if_nz           jmp     #hs_stream_in_ret
' process
                        mov     counter, #mb#MBOX_LEN_B
                        mov     r1, MBO_START_ADDR
                        call    #chk_last_elem  ' will possibly change the counter!
:loop
                        rdbyte  r2, in_addr
                        add     in_addr, #1
                        wrbyte  r2, r1
                        add     r1, #1
                        djnz    counter, #:loop
' RELEASE = write back len or len || BIT7
                        wrbyte  p1, MBO_LEN_ADDR
hs_stream_in_ret        ret
'
' --------------------------------------------------
'
chk_last_elem  ' Param: p1 (out) - value to write back to len field of mbox (counter or counter + mb#MBOX_LEN_B)
                        mov     p1, in_endaddr
                        sub     p1, in_addr
                        max     p1, counter wc,wz
        if_be           mov     counter, p1
        if_be           or      p1, BIT7
        if_be           mov     end_flag, BIT7
chk_last_elem_ret       ret
'
' --------------------------------------------------
'
hs_stream_out  ' parameter: r1(in) ... flags last element to process
' WAIT
                        rdbyte  r1, MBI_LEN_ADDR wz
        if_z            jmp     #hs_stream_out_ret
' process
' check for last element to process
                        mov     counter, r1
'not needed!                        test    r1, BIT7 wz  ' bit 7 flags the end
                        andn    counter, BIT7  ' if_nz is also not needed
                        mov     r2, MBI_START_ADDR
:loop
                        rdbyte  r3, r2
                        add     r2, #1
                        wrbyte  r3, out_addr
                        add     out_addr, #1
                        djnz    counter, #:loop
' RELEASE = write back 0
                        wrbyte  counter, MBI_LEN_ADDR
                        test    r1, BIT7 wz  ' bit 7 flags the end
        if_nz           wrbyte  BIT7, END_FLAG_ADDR
hs_stream_out_ret       ret

counter       long  0
D_IN_ADDR     long  0  ' array with input data
D_OUT_ADDR    long  0  ' array with output data
D_LEN         long  0  ' length of input array (= length of output array)
in_addr       long  0
in_endaddr    long  0  ' points to the first addr after the input array
out_addr      long  0
BIT7          long  1 << 7

                        fit     496
